pipeline {
  agent any

  environment {
    SORRY_CYPRESS_CLOUD_SERVICE_URL= 'http://sorry-cypress.confido.internal:1234/'
    SORRY_CYPRESS_RECORD_KEY = 1
    SORRY_CYPRESS_DOCKER_IMAGE = 'jenkins-cypress'
    NO_COLOR = 1
  }

  stages {
    stage("Build Cypress runner") {
      environment { 
        SORRY_CYPRESS_PROJECT_ID = "${PROJECT_ID}" 
      }
      steps {
        script {
          dockerImage = docker.build(SORRY_CYPRESS_DOCKER_IMAGE, "-f ./Dockerfile .")
        }
      }
    }
    stage("Run Cypress") {
      environment { 
        SORRY_CYPRESS_PROJECT_ID = "${PROJECT_ID}"
      }
      steps {
        script {
          sh '''docker run --net=cypresstests \
            -e CI_BUILD_ID=$GIT_BRANCH-$GIT_COMMIT \
            -e SORRY_CYPRESS_PROJECT_ID=$SORRY_CYPRESS_PROJECT_ID \
            -e CYPRESS_API_URL=$SORRY_CYPRESS_CLOUD_SERVICE_URL \
            -e SORRY_CYPRESS_CLOUD_SERVICE_URL=$SORRY_CYPRESS_CLOUD_SERVICE_URL \
            -e SORRY_CYPRESS_RECORD_KEY=$SORRY_CYPRESS_RECORD_KEY \
            -w /e2e \
            -v /var/run/docker.sock:/var/run/docker.sock \
            ${SORRY_CYPRESS_DOCKER_IMAGE}
          '''
        }
      }
    }
  }
  post {
    always {
      cleanWs()
    }
  }
}